-------------------------------------------------------------------------------
--                L  O  C  A  L     V  A  R  I  A  B  L  E  S
-------------------------------------------------------------------------------

local addonName, L = ...;

local NUM_MOUNTS_PER_ROW  = 6;
local NUM_MOUNTS_PER_PAGE = 12;

local mountData =
{
  [75207] = 0x04, -- Abyssal Seahorse
  [48778] = 0x01, -- Acherus Deathcharger
  [60025] = 0x02, -- Albino Drake
  [43688] = 0x01, -- Amani War Bear
  [16056] = 0x01, -- Ancient Frostsaber
  [66906] = 0x01, -- Argent Charger
  [63844] = 0x02, -- Argent Hippogryph
  [67466] = 0x01, -- Argent Warhorse
  [66907] = 0x01, -- Argent Warhorse
  [61230] = 0x02, -- Armored Blue Wind Rider
  [60114] = 0x01, -- Armored Brown Bear
  [60116] = 0x01, -- Armored Brown Bear
  [61229] = 0x02, -- Armored Snowy Gryphon
  [40192] = 0x02, -- Ashes of Al'ar
  [59567] = 0x02, -- Azure Drake
  [41514] = 0x02, -- Azure Netherwing Drake
  [51412] = 0x01, -- Big Battle Bear
  [58983] = 0x07, -- Big Blizzard Bear
  [71342] = 0x01, -- Big Love Rocket
  [22719] = 0x01, -- Black Battlestrider
  [59650] = 0x02, -- Black Drake
  [35022] = 0x01, -- Black Hawkstrider
  [16055] = 0x01, -- Black Nightsaber
  [59976] = 0x02, -- Black Proto-Drake
  [26656] = 0x01, -- Black Qiraji Battle Tank
  [17461] = 0x01, -- Black Ram
  [64977] = 0x01, -- Black Skeletal Horse
  [  470] = 0x01, -- Black Stallion
  [60118] = 0x01, -- Black War Bear
  [60119] = 0x01, -- Black War Bear
  [48027] = 0x01, -- Black War Elekk
  [22718] = 0x01, -- Black War Kodo
  [59785] = 0x01, -- Black War Mammoth
  [59788] = 0x01, -- Black War Mammoth
  [22720] = 0x01, -- Black War Ram
  [22721] = 0x01, -- Black War Raptor
  [22717] = 0x01, -- Black War Steed
  [22723] = 0x01, -- Black War Tiger
  [22724] = 0x01, -- Black War Wolf
  [64658] = 0x01, -- Black Wolf
  [74856] = 0x02, -- Blazing Hippogryph
  [72808] = 0x02, -- Bloodbathed Frostbrood Vanquisher
  [61996] = 0x02, -- Blue Dragonhawk
  [59568] = 0x02, -- Blue Drake
  [35020] = 0x01, -- Blue Hawkstrider
  [10969] = 0x01, -- Blue Mechanostrider
  [59996] = 0x02, -- Blue Proto-Drake
  [25953] = 0x01, -- Blue Qiraji Battle Tank
  [39803] = 0x02, -- Blue Riding Nether Ray
  [17463] = 0x01, -- Blue Skeletal Horse
  [64656] = 0x01, -- Blue Skeletal Warhorse
  [32244] = 0x02, -- Blue Wind Rider
  [50869] = 0x01, -- Brewfest Kodo
  [43899] = 0x01, -- Brewfest Ram
  [59569] = 0x02, -- Bronze Drake
  [34406] = 0x01, -- Brown Elekk
  [  458] = 0x01, -- Brown Horse
  [18990] = 0x01, -- Brown Kodo
  [ 6899] = 0x01, -- Brown Ram
  [88748] = 0x01, -- Brown Riding Camel
  [17464] = 0x01, -- Brown Skeletal Horse
  [ 6654] = 0x01, -- Brown Wolf
  [58615] = 0x02, -- Brutal Nether Drake
  [75614] = 0x00, -- Celestial Steed
  [43927] = 0x02, -- Cenarion War Hippogryph
  [ 6648] = 0x01, -- Chestnut Mare
  [41515] = 0x02, -- Cobalt Netherwing Drake
  [39315] = 0x01, -- Cobalt Riding Talbuk
  [34896] = 0x01, -- Cobalt War Talbuk
  [73313] = 0x01, -- Crimson Deathcharger
  [68188] = 0x01, -- Crusader's Black Warhorse
  [68187] = 0x01, -- Crusader's White Warhorse
  [88990] = 0x02, -- Dark Phoenix
  [39316] = 0x01, -- Dark Riding Talbuk
  [34790] = 0x01, -- Dark War Talbuk
  [63635] = 0x01, -- Darkspear Raptor
  [63637] = 0x01, -- Darnassian Nightsaber
  [64927] = 0x02, -- Deadly Gladiator's Frost Wyrm
  [ 6653] = 0x01, -- Dire Wolf
  [88335] = 0x02, -- Drake of the East Wind
  [88742] = 0x02, -- Drake of the North Wind
  [88744] = 0x02, -- Drake of the South Wind
  [88741] = 0x02, -- Drake of the West Wind
  [23161] = 0x01, -- Dreadsteed
  [32239] = 0x02, -- Ebon Gryphon
  [ 8395] = 0x01, -- Emerald Raptor
  [63639] = 0x01, -- Exodar Elekk
  [ 5784] = 0x01, -- Felsteed
  [36702] = 0x01, -- Fiery Warhorse
  [61451] = 0x03, -- Flying Carpet
  [44153] = 0x02, -- Flying Machine
  [63643] = 0x01, -- Forsaken Warhorse
  [84751] = 0x01, -- Fossilized Raptor
  [17460] = 0x01, -- Frost Ram
  [23509] = 0x01, -- Frostwolf Howler
  [75596] = 0x03, -- Frosty Flying Carpet
  [65439] = 0x02, -- Furious Gladiator's Frost Wyrm
  [63638] = 0x01, -- Gnomeregan Mechanostrider
  [89520] = 0x01, -- Goblin Mini Hotrod
  [87090] = 0x01, -- Goblin Trike
  [87091] = 0x01, -- Goblin Turbo-Trike
  [32235] = 0x02, -- Golden Gryphon
  [90621] = 0x01, -- Golden King
  [61465] = 0x01, -- Grand Black War Mammoth
  [61467] = 0x01, -- Grand Black War Mammoth
  [61469] = 0x01, -- Grand Ice Mammoth
  [61470] = 0x01, -- Grand Ice Mammoth
  [35710] = 0x01, -- Gray Elekk
  [18989] = 0x01, -- Gray Kodo
  [ 6777] = 0x01, -- Gray Ram
  [35713] = 0x01, -- Great Blue Elekk
  [49379] = 0x01, -- Great Brewfest Kodo
  [23249] = 0x01, -- Great Brown Kodo
  [65641] = 0x01, -- Great Golden Kodo
  [23248] = 0x01, -- Great Gray Kodo
  [35712] = 0x01, -- Great Green Elekk
  [35714] = 0x01, -- Great Purple Elekk
  [65637] = 0x01, -- Great Red Elekk
  [23247] = 0x01, -- Great White Kodo
  [18991] = 0x01, -- Green Kodo
  [17453] = 0x01, -- Green Mechanostrider
  [61294] = 0x02, -- Green Proto-Drake
  [26056] = 0x01, -- Green Qiraji Battle Tank
  [39798] = 0x02, -- Green Riding Nether Ray
  [17465] = 0x01, -- Green Skeletal Warhorse
  [32245] = 0x02, -- Green Wind Rider
  [88750] = 0x01, -- Grey Riding Camel
  [48025] = 0x03, -- Headless Horseman's Mount
  [59797] = 0x01, -- Ice Mammoth
  [59799] = 0x01, -- Ice Mammoth
  [72807] = 0x02, -- Icebound Frostbrood Vanquisher
  [17459] = 0x01, -- Icy Blue Mechanostrider Mod A
  [72286] = 0x07, -- Invincible
  [63956] = 0x02, -- Ironbound Proto-Drake
  [63636] = 0x01, -- Ironforge Ram
  [17450] = 0x01, -- Ivory Raptor
  [93644] = 0x01, -- Kor'kron Annihilator
  [65917] = 0x01, -- Magic Rooster
  [61309] = 0x03, -- Magnificent Flying Carpet
  [55531] = 0x01, -- Mechano-Hog
  [60424] = 0x01, -- Mekgineer's Chopper
  [44744] = 0x02, -- Merciless Nether Drake
  [63796] = 0x02, -- Mimiron's Head
  [93623] = 0x02, -- Mottled Drake
  [16084] = 0x01, -- Mottled Red Raptor
  [66846] = 0x01, -- Ochre Skeletal Warhorse
  [41513] = 0x02, -- Onyx Netherwing Drake
  [69395] = 0x02, -- Onyxian Drake
  [63640] = 0x01, -- Orgrimmar Wolf
  [16082] = 0x01, -- Palomino
  [32345] = 0x02, -- Peep the Phoenix Mount
  [88718] = 0x02, -- Phosphorescent Stone Drake
  [  472] = 0x01, -- Pinto
  [60021] = 0x02, -- Plagued Proto-Drake
  [35711] = 0x01, -- Purple Elekk
  [35018] = 0x01, -- Purple Hawkstrider
  [41516] = 0x02, -- Purple Netherwing Drake
  [39801] = 0x02, -- Purple Riding Nether Ray
  [23246] = 0x01, -- Purple Skeletal Warhorse
  [66090] = 0x01, -- Quel'dorei Steed
  [41252] = 0x01, -- Raven Lord
  [61997] = 0x02, -- Red Dragonhawk
  [59570] = 0x02, -- Red Drake
  [34795] = 0x01, -- Red Hawkstrider
  [10873] = 0x01, -- Red Mechanostrider
  [59961] = 0x02, -- Red Proto-Drake
  [26054] = 0x01, -- Red Qiraji Battle Tank
  [39800] = 0x02, -- Red Riding Nether Ray
  [17462] = 0x01, -- Red Skeletal Horse
  [22722] = 0x01, -- Red Skeletal Warhorse
  [16080] = 0x01, -- Red Wolf
  [67336] = 0x02, -- Relentless Gladiator's Frost Wyrm
  [30174] = 0x05, -- Riding Turtle
  [17481] = 0x01, -- Rivendare's Deathcharger
  [63963] = 0x02, -- Rusted Proto-Drake
  [93326] = 0x02, -- Sandstone Drake
  [64731] = 0x04, -- Sea Turtle
  [66087] = 0x02, -- Silver Covenant Hippogryph
  [39802] = 0x02, -- Silver Riding Nether Ray
  [39317] = 0x01, -- Silver Riding Talbuk
  [34898] = 0x01, -- Silver War Talbuk
  [63642] = 0x01, -- Silvermoon Hawkstrider
  [32240] = 0x02, -- Snowy Gryphon
  [92231] = 0x01, -- Spectral Steed
  [42776] = 0x01, -- Spectral Tiger
  [92232] = 0x01, -- Spectral Wolf
  [10789] = 0x01, -- Spotted Frostsaber
  [23510] = 0x01, -- Stormpike Battle Charger
  [63232] = 0x01, -- Stormwind Steed
  [66847] = 0x01, -- Striped Dawnsaber
  [ 8394] = 0x01, -- Striped Frostsaber
  [10793] = 0x01, -- Striped Nightsaber
  [23214] = 0x01, -- Summon Charger
  [34767] = 0x01, -- Summon Charger
  [73629] = 0x01, -- Summon Exarch's Elekk
  [73630] = 0x01, -- Summon Great Exarch's Elekk
  [69826] = 0x01, -- Summon Great Sunwalker Kodo
  [69820] = 0x01, -- Summon Sunwalker Kodo
  [13819] = 0x01, -- Summon Warhorse
  [34769] = 0x01, -- Summon Warhorse
  [66088] = 0x02, -- Sunreaver Dragonhawk
  [66091] = 0x01, -- Sunreaver Hawkstrider
  [68057] = 0x01, -- Swift Alliance Steed
  [32242] = 0x02, -- Swift Blue Gryphon
  [23241] = 0x01, -- Swift Blue Raptor
  [43900] = 0x01, -- Swift Brewfest Ram
  [23238] = 0x01, -- Swift Brown Ram
  [23229] = 0x01, -- Swift Brown Steed
  [23250] = 0x01, -- Swift Brown Wolf
  [65646] = 0x01, -- Swift Burgundy Wolf
  [23221] = 0x01, -- Swift Frostsaber
  [23239] = 0x01, -- Swift Gray Ram
  [65640] = 0x01, -- Swift Gray Steed
  [23252] = 0x01, -- Swift Gray Wolf
  [32290] = 0x02, -- Swift Green Gryphon
  [35025] = 0x01, -- Swift Green Hawkstrider
  [23225] = 0x01, -- Swift Green Mechanostrider
  [32295] = 0x02, -- Swift Green Wind Rider
  [68056] = 0x01, -- Swift Horde Wolf
  [23219] = 0x01, -- Swift Mistsaber
  [65638] = 0x01, -- Swift Moonsaber
  [37015] = 0x02, -- Swift Nether Drake
  [23242] = 0x01, -- Swift Olive Raptor
  [23243] = 0x01, -- Swift Orange Raptor
  [23227] = 0x01, -- Swift Palomino
  [33660] = 0x01, -- Swift Pink Hawkstrider
  [32292] = 0x02, -- Swift Purple Gryphon
  [35027] = 0x01, -- Swift Purple Hawkstrider
  [65644] = 0x01, -- Swift Purple Raptor
  [32297] = 0x02, -- Swift Purple Wind Rider
  [24242] = 0x01, -- Swift Razzashi Raptor
  [32289] = 0x02, -- Swift Red Gryphon
  [65639] = 0x01, -- Swift Red Hawkstrider
  [32246] = 0x02, -- Swift Red Wind Rider
  [42777] = 0x01, -- Swift Spectral Tiger
  [23338] = 0x01, -- Swift Stormsaber
  [23251] = 0x01, -- Swift Timber Wolf
  [65643] = 0x01, -- Swift Violet Ram
  [35028] = 0x01, -- Swift Warstrider
  [46628] = 0x01, -- Swift White Hawkstrider
  [23223] = 0x01, -- Swift White Mechanostrider
  [23240] = 0x01, -- Swift White Ram
  [23228] = 0x01, -- Swift White Steed
  [23222] = 0x01, -- Swift Yellow Mechanostrider
  [32296] = 0x02, -- Swift Yellow Wind Rider
  [49322] = 0x01, -- Swift Zhevra
  [24252] = 0x01, -- Swift Zulian Tiger
  [88749] = 0x01, -- Tan Riding Camel
  [39318] = 0x01, -- Tan Riding Talbuk
  [34899] = 0x01, -- Tan War Talbuk
  [32243] = 0x02, -- Tawny Wind Rider
  [18992] = 0x01, -- Teal Kodo
  [63641] = 0x01, -- Thunder Bluff Kodo
  [  580] = 0x01, -- Timber Wolf
  [60002] = 0x02, -- Time-Lost Proto-Drake
  [61425] = 0x01, -- Traveler's Tundra Mammoth
  [61447] = 0x01, -- Traveler's Tundra Mammoth
  [44151] = 0x02, -- Turbo-Charged Flying Machine
  [65642] = 0x01, -- Turbostrider
  [10796] = 0x01, -- Turquoise Raptor
  [59571] = 0x02, -- Twilight Drake
  [92155] = 0x01, -- Ultramarine Qiraji Battle Tank
  [17454] = 0x01, -- Unpainted Mechanostrider
  [49193] = 0x02, -- Vengeful Nether Drake
  [64659] = 0x01, -- Venomhide Ravasaur
  [41517] = 0x02, -- Veridian Netherwing Drake
  [41518] = 0x02, -- Violet Netherwing Drake
  [60024] = 0x02, -- Violet Proto-Drake
  [10799] = 0x01, -- Violet Raptor
  [88746] = 0x02, -- Vitreous Stone Drake
  [88331] = 0x02, -- Volcanic Stone Drake
  [64657] = 0x01, -- White Kodo
  [15779] = 0x01, -- White Mechanostrider Mod B
  [54753] = 0x01, -- White Polar Bear
  [ 6898] = 0x01, -- White Ram
  [39319] = 0x01, -- White Riding Talbuk
  [65645] = 0x01, -- White Skeletal Warhorse
  [16083] = 0x01, -- White Stallion
  [34897] = 0x01, -- White War Talbuk
  [54729] = 0x00, -- Winged Steed of the Ebon Blade
  [16081] = 0x01, -- Winter Wolf
  [17229] = 0x01, -- Winterspring Frostsaber
  [59791] = 0x01, -- Wooly Mammoth
  [59793] = 0x01, -- Wooly Mammoth
  [74918] = 0x01, -- Wooly White Rhino
  [71810] = 0x02, -- Wrathful Gladiator's Frost Wyrm
  [46197] = 0x02, -- X-51 Nether-Rocket
  [46199] = 0x02, -- X-51 Nether-Rocket X-TREME
  [75973] = 0x07, -- X-53 Touring Rocket
  [26055] = 0x01, -- Yellow Qiraji Battle Tank
  [  783] = 0x01, -- Travel Form
  [ 1066] = 0x04, -- Aquatic Form
  [33943] = 0x02, -- Flight Form
  [40120] = 0x02, -- Swift Flight Form
  [ 2645] = 0x01  -- Ghost Wolf
};

local mountSpells =
{
    783, -- Travel Form
   1066, -- Aquatic Form
  33943, -- Flight Form
  40120, -- Swift Flight Form
   2645  -- Ghost Wolf
};

local mountRestricted =
{
  -- Abyssal Seahorse
  [75207] =
  {
    [L["Shimmering Expanse"]] = true,
    [L["Abyssal Depths"]]     = true,
    [L["Kelp'thar Forest"]]   = true
  },
  [25953] = -- Blue Qiraji Battle Tank
  {
    [L["Ahn'Qiraj"]] = true
  },
  [26056] = -- Green Qiraji Battle Tank
  {
    [L["Ahn'Qiraj"]] = true
  },
  [26054] = -- Red Qiraji Battle Tank
  {
    [L["Ahn'Qiraj"]] = true
  },
  [26055] = -- Yellow Qiraji Battle Tank
  {
    [L["Ahn'Qiraj"]] = true
  }
};

local continentalFlight = {};

local isTravelForm = {};
local mountMacroText = "";

-------------------------------------------------------------------------------
--                L  O  C  A  L     F  U  N  C  T  I  O  N  S
-------------------------------------------------------------------------------

-------------------------------------------------------------------------------
--                G  L  O  B  A  L    F  U  N  C  T  I  O  N  S
-------------------------------------------------------------------------------

--
-- Function clear the macro of the hidden mount button after it has been
-- 'clicked'.
--
function NigglesMountPostClick(button)
  -- Clear the button's macro
  if (InCombatLockdown() == nil) then
    button:SetAttribute("macrotext", mountMacroText);
  end
end

--
-- Function to work out what to do when a macro calls '/click NigglesMount'.
-- This function is called before the button is 'clicked'. It works out what
-- to do based on the player's current status and changes the macro of the
-- hidden button accordingly.
--
function NigglesMountPreClick(button)
  -- Local Variables
  local currentContinent;
  local currentZone;
  local formIdx = GetShapeshiftForm();
  local index = 0;
  local isWintergraspBattle = false;
  local macroText = "";
  local mountIdx;
  local mountName;
  local mountType = nil;
  local numMounts = 0;
  local randomList = {{}, {}};
  local spellName = "";
  local wintergraspName;

  -- Reset the map to the current zone
  SetMapToCurrentZone();

  -- Get the current continent
  currentContinent = GetCurrentMapContinent();

  -- Get the name of the current zone
  currentZone = GetRealZoneText();

  -- Get info about Wintergrasp
  _, wintergraspName, isWintergraspBattle = GetWorldPVPAreaInfo(1);

  -- Work out what to do, based on the player's current location and state
  if (UnitInVehicle("player")) then
    -- Exit any vehicle the player is in
    VehicleExit();
  elseif (IsMounted() == 1) then
    -- Dismount from any mount the player is on
    Dismount();
  elseif ((formIdx > 0) and
          (isTravelForm[formIdx] == true) and
          (InCombatLockdown() == nil)) then
    -- Cancel the current shapeshift form
    button:SetAttribute("macrotext", "/cancelform [form:"..formIdx.."]");
  elseif ((not IsModifierKeyDown()) and
          (IsSwimming())) then
    -- If swimming mounts have been selected...
    if (next(NigglesDBC.mounts.swim) ~= nil) then
      -- ...use that type of mounts
      mountType = "swim";
    else
      mountType = "run";
    end
  elseif ((not IsModifierKeyDown()) and
          (IsFlyableArea())) then
    -- Work out if the player can fly
    if ((continentalFlight[currentContinent] == true) and
        ((currentContinent ~= 4) or
         (currentZone ~= wintergraspName) or
         (isWintergraspBattle ~= true))) then
      mountType = "fly";
    else
      mountType = "run";
    end
  else
    mountType = "run";
  end

  -- Check if the player is in combat
  if (mountType ~= nil) then
    if (InCombatLockdown() == 1) then
      UIErrorsFrame:AddMessage(SPELL_FAILED_AFFECTING_COMBAT,
        1.0, 0.1, 0.1, 1.0);
    elseif (next(NigglesDBC.mounts[mountType]) == nil) then
      UIErrorsFrame:AddMessage(L["No mounts selected"], 1.0, 0.1, 0.1, 1.0);
    else
      -- Build restricted & unrestricted lists of selected mounts
      for spellId, _ in pairs(NigglesDBC.mounts[mountType]) do
        if (mountRestricted[spellId] ~= nil) then
          if (mountRestricted[spellId][currentZone] == true) then
            table.insert(randomList[1], spellId);
          end
        else
          table.insert(randomList[2], spellId);
        end
      end

      -- Randomly select a mount, prioritizing those restricted to current zone
      if (#(randomList[1]) > 0) then
        spellName = GetSpellInfo(randomList[1][math.random(#(randomList[1]))]);
      elseif (#(randomList[2]) > 0) then
        spellName = GetSpellInfo(randomList[2][math.random(#(randomList[2]))]);
      end

      -- Update the button with the mount's spell name
      if (spellName ~= "") then
        button:SetAttribute("macrotext",
          mountMacroText.."/cast "..spellName);
      else
        button:SetAttribute("macrotext", "");
        UIErrorsFrame:AddMessage(L["No suitable mount"], 1.0, 0.1, 0.1, 1.0);
      end
    end
  end

  return;
end

--
-- Function to initialise a Mounts frame
--
function NigglesMountsFrameInit(frame, mountType, mask, text, tooltip)
  -- Save the mount type and mask
  frame.mountType = mountType;
  frame.mountMask = mask;

  -- Initialise the text
  _G[frame:GetName().."LabelText"]:SetText(L[text]);
  _G[frame:GetName().."Label"].tooltip = L[tooltip];

  return;
end

--
-- Function to update the mounts displayed by a frame in the Niggles Options
-- Mounts panel.
--
function NigglesMountsListUpdate(frame)
  -- Local Variables
  local button;
  local creatureId;
  local creatureName;
  local frameName;
  local icon;
  local mount = {};
  local mountIdx;
  local numCompanions;
  local numMounts = 0;
  local scrollbar;
  local spellId;
  local topLine;

  -- Check the required variables are initialised
  if ((Niggles.updatedOptions ~= nil) and
      (Niggles.updatedOptions.mounts ~= nil) and
      (frame.mountType ~= nil) and
      (Niggles.updatedOptions.mounts[frame.mountType] ~= nil)) then
    -- Get the frame's name
    frameName = frame:GetName();

    -- Get the number of mounts
    numCompanions = GetNumCompanions("MOUNT");

    -- Add any know mount spells, based on the filter
    for _, spellId in ipairs(mountSpells) do
      if ((mountData[spellId] ~= nil) and
          (bit.band(mountData[spellId], frame.mountMask) ==
            frame.mountMask) and
          (IsSpellKnown(spellId))) then
        numMounts = numMounts+1;
        mount[numMounts]            = {};
        mount[numMounts].spellId    = spellId;
        _, _, mount[numMounts].icon = GetSpellInfo(spellId);
      end
    end

    -- Add any known mounts that match the filter
    for mountIdx = 1, numCompanions do
      creatureId, creatureName, spellId, icon =
        GetCompanionInfo("MOUNT", mountIdx);
      if ((mountData[spellId] == nil) or
          ((mountData[spellId] ~= nil) and
           (bit.band(mountData[spellId], frame.mountMask) ==
             frame.mountMask))) then
        numMounts = numMounts+1;
        mount[numMounts]              = {};
        mount[numMounts].creatureId   = creatureId;
        mount[numMounts].creatureName = creatureName;
        mount[numMounts].spellId      = spellId;
        mount[numMounts].icon         = icon;
      end
    end

    -- Get the frame's scrollbar
    scrollbar = _G[frameName.."CompanionsScrollbar"];

    -- Make sure the top line displayed is still valid
    topLine = FauxScrollFrame_GetOffset(scrollbar);
    if (topLine > math.ceil(numMounts/NUM_MOUNTS_PER_ROW)) then
      -- Work out the new top line
      topLine = math.ceil(numMounts/NUM_MOUNTS_PER_ROW)-1;
      if (topLine < 0) then
        topLine = 0;
      end

      -- Set the new top line
      FauxScrollFrame_SetOffset(scrollbar, topLine);
    end

    -- Update all the buttons
    for buttonIdx = 1, NUM_MOUNTS_PER_PAGE do
      -- Get the current button
      button = _G[frameName.."Companions"..buttonIdx];

      -- Work out the index of the mount to display in the button
      mountIdx = (topLine*NUM_MOUNTS_PER_ROW)+buttonIdx;
      if (mountIdx <= numMounts) then
        -- Update the button
        button.creatureId   = mount[mountIdx].creatureId;
        button.creatureName = mount[mountIdx].creatureName;
        button.spellId      = mount[mountIdx].spellId;
        button:SetNormalTexture(mount[mountIdx].icon);
        if (Niggles.updatedOptions.mounts[frame.mountType][button.spellId] ~=
             nil) then
          button:SetChecked(true);
        else
          button:SetChecked(false);
        end
        button:Enable();
      else
        -- Update the button
        button:SetChecked(false);
        button:Disable();
      end
    end

    -- Update the scrollbar
    FauxScrollFrame_Update(scrollbar,
      math.ceil(numMounts/NUM_MOUNTS_PER_ROW), 2, 37,
      nil, 0, 0, nil, 0, 0, true);
  end

  return;
end

--
-- Function to scroll the list of mounts
--
function NigglesMountsListScroll(frame)
  NigglesMountsListUpdate(frame:GetParent());

  return;
end

--
-- Function to process clicks on check buttons in the Niggles Options
-- Mount panel.
--
function NigglesMountClicked(checkButton)
  -- Local Variables
  local mountType;

  -- Check the button has the required info
  if ((checkButton ~= nil) and
      (checkButton.spellId ~= nil)) then
    -- Get the type of mount the check button is for
    mountType = (checkButton:GetParent()):GetParent().mountType;
    if (Niggles.updatedOptions.mounts[mountType] ~= nil) then
      Niggles.updatedOptions.mounts[mountType][checkButton.spellId] =
        checkButton:GetChecked();
    end
  end

  return;
end

--
-- Function called when the player's spells change
--
function NigglesMountsSpellsUpdate()
  -- Local Variables
  local formIdx;
  local formName;
  local idx;
  local numContinents = select("#", GetMapContinents());
  local numForms = GetNumShapeshiftForms();
  local spellId;
  local spellName;

  -- Clear the continental flight table
  for idx = 1, numContinents do
    continentalFlight[idx] = false;
  end

  -- Check if the player has the skill to fly
  if ((IsSpellKnown(34090)) or    -- Expert Riding
      (IsSpellKnown(34091)) or    -- Artisan Riding
      (IsSpellKnown(90265))) then -- Master Riding
    -- Check if the player can fly in Azeroth
    if (IsSpellKnown(90267)) then -- Flight Pilot's License
      continentalFlight[1] = true;
      continentalFlight[2] = true;
      continentalFlight[5] = true;
    end

    -- Set the flag that indicates the player can fly in Outland
    continentalFlight[3] = true;

    -- Check if the player can fly in Northrend
    if (IsSpellKnown(54197)) then -- Cold Weather Flying
      continentalFlight[4] = true;
    end
  end

  -- Work out which forms are travel forms
  wipe(isTravelForm);
  for idx, spellId in ipairs(mountSpells) do
    spellName = GetSpellInfo(spellId);
    if (spellName ~= nil) then
      for formIdx = 1, numForms do
        _, formName = GetShapeshiftFormInfo(formIdx);
        if ((formName ~= nil) and
            (formName == spellName)) then
          isTravelForm[formIdx] = true;
          break;
        end
      end
    end
  end

  -- Build the macro text for the mount button
  mountMacroText = "";
  for idx = 1, numForms do
    if (isTravelForm[idx] == true) then
      mountMacroText = mountMacroText.."[combat,form:"..idx.."]";
    else
      isTravelForm[idx] = false;
    end
  end
  if (mountMacroText ~= "") then
    mountMacroText = "/cancelform "..mountMacroText.."\n";
  end

  return
end

--
-- Function to refresh the settings for the Niggles Options Mounts panel.
--
function NigglesOptionsRefreshMounts()
  -- Set the scroll frames to the top
  FauxScrollFrame_OnVerticalScroll(
    NigglesOptionsMountsRunCompanionsScrollbar,  0, 37, nil);
  NigglesMountsListUpdate(NigglesOptionsMountsRun);
  FauxScrollFrame_OnVerticalScroll(
    NigglesOptionsMountsFlyCompanionsScrollbar,  0, 37, nil);
  NigglesMountsListUpdate(NigglesOptionsMountsFly);
  FauxScrollFrame_OnVerticalScroll(
    NigglesOptionsMountsSwimCompanionsScrollbar, 0, 37, nil);
  NigglesMountsListUpdate(NigglesOptionsMountsSwim);

  return;
end
